#version 150

in vec3 Position;
in vec2 UV0;

uniform sampler2D Sampler0;
uniform mat4 ModelViewMat;
uniform mat4 ProjMat;
uniform vec2 ScreenSize;

out vec2 texCoord0;

#define CROSSHAIRSIZE 0.05
#define CROSSHAIRSIZEMIN 80.0
#define FUDGE 0.999

void main() {
    vec4 pos = ProjMat * ModelViewMat * vec4(Position, 1.0);
    float ratio = ScreenSize.y / ScreenSize.x;
    texCoord0 = UV0;
    

    if (abs(pos.x) <= 0.1 * ratio && abs(pos.y) <= 0.1 && Position.z == 0.0 && UV0.x < 1.0 / 16.0 && UV0.y < 1.0 / 16.0 && ModelViewMat[3][0] == 0.0 && ModelViewMat[3][1] == 0.0) {
        if (pos.x < 0.0) {
            pos.x = -max(CROSSHAIRSIZE * ratio, CROSSHAIRSIZEMIN / ScreenSize.x);
            texCoord0.x = 1.0 / 16.0 * (1.0 - FUDGE);
        } else {
            texCoord0.x = 1.0 / 16.0 * FUDGE;
            pos.x = max(CROSSHAIRSIZE * ratio, CROSSHAIRSIZEMIN / ScreenSize.x);
        }
        if (pos.y < 0.0) {
            texCoord0.y = 1.0 / 16.0 * (1.0 - FUDGE);
            pos.y = -max(CROSSHAIRSIZE, CROSSHAIRSIZEMIN / ScreenSize.y);
        } else {
            texCoord0.y = 1.0 / 16.0 * FUDGE;
            pos.y = max(CROSSHAIRSIZE, CROSSHAIRSIZEMIN / ScreenSize.y);
        }
        if (int(ScreenSize.x) % 2 == 1) {
            pos.x -= 1.0 / ScreenSize.x;
        }
        if (int(ScreenSize.y) % 2 == 1) {
            pos.y -= 1.0 / ScreenSize.y;
        }
    }
    gl_Position = pos;
}
